package cn.ibizlab.businesscentral.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.base.domain.KnowledgeArticleViews;
import cn.ibizlab.businesscentral.core.base.filter.KnowledgeArticleViewsSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[KnowledgeArticleViews] 服务对象接口
 */
public interface IKnowledgeArticleViewsService extends IService<KnowledgeArticleViews>{

    KnowledgeArticleViews getDraft(KnowledgeArticleViews et) ;
    boolean update(KnowledgeArticleViews et) ;
    void updateBatch(List<KnowledgeArticleViews> list) ;
    boolean save(KnowledgeArticleViews et) ;
    void saveBatch(List<KnowledgeArticleViews> list) ;
    boolean checkKey(KnowledgeArticleViews et) ;
    boolean create(KnowledgeArticleViews et) ;
    void createBatch(List<KnowledgeArticleViews> list) ;
    KnowledgeArticleViews get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Page<KnowledgeArticleViews> searchDefault(KnowledgeArticleViewsSearchContext context) ;
    List<KnowledgeArticleViews> selectByKnowledgearticleid(String knowledgearticleid) ;
    void removeByKnowledgearticleid(String knowledgearticleid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<KnowledgeArticleViews> getKnowledgearticleviewsByIds(List<String> ids) ;
    List<KnowledgeArticleViews> getKnowledgearticleviewsByEntities(List<KnowledgeArticleViews> entities) ;

}


